
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RoomsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const rooms = await db.rooms.create(
            {
                id: data.id || undefined,
        
        room_number: data.room_number
        ||
        null
            ,
            
        floor: data.floor
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await rooms.setHotel( data.hotel || null, {
            transaction,
        });
        
        await rooms.setRoom_type( data.room_type || null, {
            transaction,
        });
        
        await rooms.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return rooms;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const roomsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                room_number: item.room_number
            ||
            null
            ,
            
                floor: item.floor
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const rooms = await db.rooms.bulkCreate(roomsData, { transaction });

        // For each item created, replace relation files
        

        return rooms;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const rooms = await db.rooms.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.room_number !== undefined) updatePayload.room_number = data.room_number;
        
        
        if (data.floor !== undefined) updatePayload.floor = data.floor;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await rooms.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await rooms.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        
        if (data.room_type !== undefined) {
            await rooms.setRoom_type(
              
              data.room_type,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await rooms.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return rooms;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const rooms = await db.rooms.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of rooms) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of rooms) {
                await record.destroy({transaction});
            }
        });


        return rooms;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const rooms = await db.rooms.findByPk(id, options);

        await rooms.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await rooms.destroy({
            transaction
        });

        return rooms;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const rooms = await db.rooms.findOne(
            { where },
            { transaction },
        );

        if (!rooms) {
            return rooms;
        }

        const output = rooms.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.reservations_room = await rooms.getReservations_room({
            transaction
        });
        
        
        
        
        
        
        
        
        output.housekeeping_tasks_room = await rooms.getHousekeeping_tasks_room({
            transaction
        });
        
        
        output.maintenance_tickets_room = await rooms.getMaintenance_tickets_room({
            transaction
        });
        
        
        
        
        
        
        
        
        output.hotel = await rooms.getHotel({
            transaction
        });
        
        
        output.room_type = await rooms.getRoom_type({
            transaction
        });
        
        
        output.organizations = await rooms.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.room_types,
        as: 'room_type',
        
        where: filter.room_type ? {
          [Op.or]: [
            { id: { [Op.in]: filter.room_type.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.room_type.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.room_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'rooms',
                        'room_number',
                        filter.room_number,
                    ),
                };
            }
            
            if (filter.floor) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'rooms',
                        'floor',
                        filter.floor,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'rooms',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.rooms.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'rooms',
                        'room_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.rooms.findAll({
            attributes: [ 'id', 'room_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['room_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.room_number,
        }));
    }

    
};

